<template>
  <v-container fluid>
    <h1>{{ title }}</h1>
    <h2>{{ orientation }}</h2>
    <v-btn v-on:click="startStream()">Start stream</v-btn>

    <v-flex xs12 md6 offset-md3>
      <canvas id="canvas"></canvas>
      <video id="video" width="100%" height="100%" autoplay></video>
    </v-flex>
  </v-container>
</template>

<script>
export default {
  name: 'ARView',
  components: {
  },
  data () {
    return {
      title: 'ARView',
      coords: [{x: 45.782257, y: 4.865057}, {x: 45.776345, y: 4.872454}],
      position: null,
      equatorial_radius: 6378.1370,
      polar_radius: 6356.7523,
      orientation: 'orientation'
    }
  },
  methods: {
    startStream: function () {
      window.addEventListener('deviceorientation', (e) => {
        this.orientation = e.alpha + ';' + e.beta + ';' + e.gamma
      }, true)

      // Grab elements, create settings, etc.
      var video = document.getElementById('video')
      var canvas = document.getElementById('canvas')
      var context = canvas.getContext('2d')

      var cw = Math.floor(video.clientWidth)
      var ch = Math.floor(video.clientHeight)
      canvas.width = cw
      canvas.height = ch

      video.addEventListener('play', () => {
        this.draw(video, context, cw, ch)
      }, false)

      // Get access to the camera!
      if (navigator.mediaDevices && navigator.mediaDevices.getUserMedia) {
        // Not adding `{ audio: true }` since we only want video now
        navigator.mediaDevices.getUserMedia({ video: true }).then(function (stream) {
          video.src = window.URL.createObjectURL(stream)
          video.play()
        })

        /* var img = document.getElementById('fleche')
        img.style.display = 'block' */
      }
    },
    updateLocation: function () {
      if (navigator.geolocation) {
        navigator.geolocation.getCurrentPosition(this.setPosition)
      } else {
        console.log('Geolocation is not supported by this browser.')
      }
    },
    setPosition: function (position) {
      this.position = {x: position.coords.latitude, y: position.coords.longitude, z: 0}
    },
    draw: function (video, canvas, w, h) {
      if (video.paused || video.ended) return false

      canvas.drawImage(video, 0, 0, w, h)

      this.updateLocation()

      // var positionEcef = this.llToEcef(this.position)

      this.coords.forEach((c) => {
        // var cEcef = this.llToEcef(c)
        // var enu = this.ecefToEnu(cEcef, positionEcef)
        // var vec = {x: enu.n, y: -enu.e, z: enu.u, w: 1}
        this.drawPoint(canvas, c)
      })

      setTimeout(this.draw, 20, video, canvas, w, h)
    },
    drawPoint: function (canvas, position) {
      canvas.fillRect(position.x, position.y, 10, 10)
    },
    llToEcef: function (position) {
      var height = 0
      var posX = position.x * Math.PI / 180
      var posY = position.y * Math.PI / 180

      var x = (this.prime(posX) + height) * Math.cos(posX) * Math.cos(posY)
      var y = (this.prime(posX) + height) * Math.cos(posX) * Math.sin(posY)
      var z = ((Math.pow(this.polar_radius, 2) / Math.pow(this.equatorial_radius, 2)) * this.prime(posX) + height) * Math.sin(posY)

      return {e: x, n: y, u: z}
    },
    prime: function (v) {
      var e2 = 1 - Math.pow(this.polar_radius, 2) / Math.pow(this.equatorial_radius, 2)
      return this.equatorial_radius / Math.sqrt(1 - e2 * Math.pow(Math.sin(v), 2))
    },
    ecefToEnu: function (pos, ref) {
      var diff = {x: pos.x - ref.x, y: pos.y - ref.y, z: pos.z - ref.z}
      var lambda = Math.atan(ref.y / pos.x)
      var posX = this.position.x * Math.PI / 180

      var mat = [[-Math.sin(lambda), Math.cos(lambda), 0],
        [-Math.sin(posX) * Math.cos(lambda), -Math.sin(posX) * Math.sin(lambda), Math.cos(posX)],
        [Math.cos(posX) * Math.cos(lambda), Math.cos(posX) * Math.sin(lambda), Math.sin(posX)]]

      var resX = mat[0][0] * diff.x + mat[0][1] * diff.y + mat[0][2] * diff.z
      var resY = mat[1][0] * diff.x + mat[1][1] * diff.y + mat[1][2] * diff.z
      var resZ = mat[2][0] * diff.x + mat[2][1] * diff.y + mat[2][2] * diff.z

      return {x: resX, y: resY, z: resZ}
    }
  }
}
</script>

<style scoped>
</style>
